futhark-0.25.27: An optimising compiler for a functional, array-oriented language.

Safe Haskell | Safe-Inferred
Language | GHC2021

Futhark.Internalise.Defunctionalise

Description

Defunctionalization of typed, monomorphic Futhark programs without modules.

Synopsis

- transformProg :: MonadFreshNames m => [ValBind] -> m [ValBind]

# Documentation

transformProg :: MonadFreshNames m => [ValBind] -> m [ValBind] Source #

Transform a list of top-level value bindings. May produce new lifted function definitions, which are placed in front of the resulting list of declarations.